// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function GetBase64Table(){
  return "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split('');
}
function GetBase64ReverseTable(){
  var table;
  var i;
  var revTable;

  table = GetBase64Table();
  revTable = [];
  revTable.length = 127;

  for(i = 0; i < table.length; i = i + 1){
    revTable[table[i].charCodeAt(0)] = i;
  }

  return revTable;
}
function GetBase64ValidTable(){
  var i;
  var validTable;

  validTable = [];
  validTable.length = 127;

  for(i = 0; i < 127; i = i + 1){
    validTable[i] = IsValidBase64Character(String.fromCharCode(i));
  }

  return validTable;
}
function IsValidBase64Character(c){
  var table;
  var isValid;
  var i;

  table = GetBase64Table();
  isValid = false;

  for(i = 0; i < table.length; i = i + 1){
    if(table[i] == c){
      isValid = true;
    }
  }

  return isValid;
}
function Base64Encode(data, encoded, message){
  var padding, triples, i, currentTriple, currentQuad;
  var data3;
  var done, success;
  var encoded4;

  padding = 0;
  if((ByteArrayLength(data)%3) == 1){
    padding = 2;
  }
  if((ByteArrayLength(data)%3) == 2){
    padding = 1;
  }
  triples = Math.ceil(ByteArrayLength(data)/3);

  /* Init */
  encoded.string = [];
  encoded.string.length = triples*4;
  message.string = "".split('');
  success = true;
  encoded4 = CreateStringReferenceLengthValue(4, 'A');
  done = false;
  data3 = CreateByteArray(3);

  for(i = 0; i < triples &&  !done ; i = i + 1){
    currentTriple = i*3;
    currentQuad = i*4;

    /* Fetch triplet. */
    if(padding > 0 && i + 1 == triples){
      if(padding == 2){
        SetByte(data3, 0, GetByte(data, currentTriple + 0));
        SetByte(data3, 1, 0);
        SetByte(data3, 2, 0);
      }else if(padding == 1){
        SetByte(data3, 0, GetByte(data, currentTriple + 0));
        SetByte(data3, 1, GetByte(data, currentTriple + 1));
        SetByte(data3, 2, 0);
      }
    }else{
      SetByte(data3, 0, GetByte(data, currentTriple + 0));
      SetByte(data3, 1, GetByte(data, currentTriple + 1));
      SetByte(data3, 2, GetByte(data, currentTriple + 2));
    }

    success = Base64Encode3Numbers(data3, encoded4, message);

    if(success){
      /* Write quad. */
      encoded.string[currentQuad + 0] = encoded4.string[0];
      encoded.string[currentQuad + 1] = encoded4.string[1];

      if(padding > 0 && i + 1 == triples){
        if(padding == 2){
          encoded.string[currentQuad + 2] = '=';
          encoded.string[currentQuad + 3] = '=';
        }else if(padding == 1){
          encoded.string[currentQuad + 2] = encoded4.string[2];
          encoded.string[currentQuad + 3] = '=';
        }
      }else{
        encoded.string[currentQuad + 2] = encoded4.string[2];
        encoded.string[currentQuad + 3] = encoded4.string[3];
      }
    }else{
      success = false;
      done = true;
    }
  }

  delete(encoded4);
  delete(data3);

  return success;
}
function Base64Encode3Numbers(data, encoded4, message){
  var i, e;
  var isWithinBounds, isWhole;
  var success;

  /* Init */
  encoded4.string[0] = 'A';
  encoded4.string[1] = 'A';
  encoded4.string[2] = 'A';
  encoded4.string[3] = 'A';
  message.string = "".split('');

  /* Check. */
  if(ByteArrayLength(data) == 3){
    success = true;

    for(i = 0; i < ByteArrayLength(data) && success; i = i + 1){
      e = GetByte(data, i);

      isWithinBounds = (e >= 0) && (e < Math.pow(2, 8));
      isWhole = IsInteger(e);
      if(isWithinBounds && isWhole){
      }else{
        message.string = "Input number is too high, too low or is not a whole number.".split('');
        success = false;
      }
    }

    if(success){
      Base64Encode3NumbersNoChecks(data, encoded4);
    }
  }else{
    message.string = "Input must contain 3 numbers.".split('');
    success = false;
  }

  return success;
}
function Base64Encode3NumbersNoChecks(data, encoded){
  var total, total2, bit6_1, bit6_2, bit6_3, bit6_4;
  var d0, d1, d2;

  d2 = GetByte(data, 2);
  d1 = GetByte(data, 1);
  d0 = GetByte(data, 0);

  total = (d0*256 + d1)*256 + d2;

  total2 = Math.floor(total/64);
  bit6_1 = total - total2*64;
  total = total2;

  total2 = Math.floor(total/64);
  bit6_2 = total - total2*64;
  total = total2;

  total2 = Math.floor(total/64);
  bit6_3 = total - total2*64;

  bit6_4 = total2;

  encoded.string[3] = GetBase64CharacterForNumber(bit6_1);
  encoded.string[2] = GetBase64CharacterForNumber(bit6_2);
  encoded.string[1] = GetBase64CharacterForNumber(bit6_3);
  encoded.string[0] = GetBase64CharacterForNumber(bit6_4);
}
function GetBase64CharacterForNumber(bit6){
  var table;

  table = GetBase64Table();

  return table[bit6];
}
function Base64EncodeFromText(data){
  var dataBytes;
  var encoded, message;
  var result;
  var success;

  dataBytes = UTF16ToUTF8(data);

  encoded = {};
  message = {};
  success = Base64Encode(dataBytes, encoded, message);

  if(success){
    result = encoded.string;
  }else{
    result = "".split('');
  }

  delete(encoded);
  delete(dataBytes);
  delete(message);

  return result;
}
function Base64Decode(data, decodedReference, message){
  var done, success;
  var data4;
  var quads, i, currentQuad, currentTriple, padding;
  var table, decoded;
  var decoded3;
  var validTable;

  table = GetBase64ReverseTable();
  validTable = GetBase64ValidTable();
  decoded3 = CreateAndFillByteArray(3, 0);

  padding = 0;
  if(data.length > 1){
    if(data[data.length - 1] == '='){
      padding = padding + 1;
    }
  }
  if(data.length > 2){
    if(data[data.length - 2] == '='){
      padding = padding + 1;
    }
  }
  quads = data.length/4;

  /* Init */
  decoded = [];
  decoded.length = quads*3 - padding;
  message.string = "".split('');
  success = true;

  done = false;
  for(i = 0; i < quads &&  !done ; i = i + 1){
    data4 = [];
    data4.length = 4;
    currentQuad = i*4;
    currentTriple = i*3;

    if(padding > 0 && (i + 1) == quads){
      if(padding == 2){
        data4[0] = data[currentQuad + 0];
        data4[1] = data[currentQuad + 1];
        data4[2] = 'A';
        data4[3] = 'A';
      }else if(padding == 1){
        data4[0] = data[currentQuad + 0];
        data4[1] = data[currentQuad + 1];
        data4[2] = data[currentQuad + 2];
        data4[3] = 'A';
      }
    }else{
      data4[0] = data[currentQuad + 0];
      data4[1] = data[currentQuad + 1];
      data4[2] = data[currentQuad + 2];
      data4[3] = data[currentQuad + 3];
    }

    success = Base64Decode4WithTable(data4, table, validTable, decoded3, message);

    if(success){
      if(padding > 0 && i + 1 == quads){
        if(padding == 2){
          decoded[currentTriple + 0] = GetByte(decoded3, 0);
        }else if(padding == 1){
          decoded[currentTriple + 0] = GetByte(decoded3, 0);
          decoded[currentTriple + 1] = GetByte(decoded3, 1);
        }
      }else{
        decoded[currentTriple + 0] = GetByte(decoded3, 0);
        decoded[currentTriple + 1] = GetByte(decoded3, 1);
        decoded[currentTriple + 2] = GetByte(decoded3, 2);
      }
    }else{
      success = false;
      done = true;
    }
  }

  decodedReference.bytes = NumberArrayToByteArray(decoded);
  delete(table);
  delete(validTable);
  FreeByteArray(decoded3);

  return success;
}
function Base64Decode4Chars(data, decoded3, message){
  var table;
  var validTable;
  var success;

  table = GetBase64ReverseTable();
  validTable = GetBase64ValidTable();

  success = Base64Decode4WithTable(data, table, validTable, decoded3, message);

  delete(validTable);
  delete(table);

  return success;
}
function Base64Decode4WithTable(data, table, validTable, decoded3, message){
  var i, valid;
  var success;

  if(data.length == 4){
    valid = 0;

    for(i = 0; i < 4; i = i + 1){
      if(IsValidBase64CharacterTable(data[i], validTable)){
        valid = valid + 1;
      }
    }

    if(valid == 4){
      Base64Decode4WithTableNoChecks(decoded3, data, table);
      success = true;
    }else{
      message.string = "Invalid character in input string.".split('');
      success = false;
    }
  }else{
    message.string = "There must be exactly four characters in the input string.".split('');
    success = false;
  }

  return success;
}
function IsValidBase64CharacterTable(c, validTable){
  return validTable[c.charCodeAt(0)];
}
function Base64Decode4NoChecks(decoded, data){
  var table;

  table = GetBase64ReverseTable();
  Base64Decode4WithTableNoChecks(decoded, data, table);
  delete(table);
}
function Base64Decode4WithTableNoChecks(decoded, data, table){
  var total, total2, bit6_1, bit6_2, bit6_3, bit6_4, byte0, byte1, byte2;

  bit6_1 = GetBase64NumberForCharacter(data[3], table);
  bit6_2 = GetBase64NumberForCharacter(data[2], table);
  bit6_3 = GetBase64NumberForCharacter(data[1], table);
  bit6_4 = GetBase64NumberForCharacter(data[0], table);

  total = ((bit6_4*64 + bit6_3)*64 + bit6_2)*64 + bit6_1;

  total2 = Math.floor(total/256);
  byte2 = total - total2*256;
  total = total2;

  total2 = Math.floor(total/256);
  byte1 = total - total2*256;

  byte0 = total2;

  SetByte(decoded, 2, byte2);
  SetByte(decoded, 1, byte1);
  SetByte(decoded, 0, byte0);
}
function GetBase64NumberForCharacter(c, table){
  return table[c.charCodeAt(0)];
}
function Base64DecodeToText(data){
  var decoded;
  var message;
  var result;
  var success;

  decoded = {};
  message = {};
  success = Base64Decode(data, decoded, message);

  if(success){
    result = UTF8ToUTF16(decoded.bytes);
    FreeByteArray(decoded.bytes);
    delete(decoded);
  }else{
    result = "".split('');
  }

  return result;
}
function TestDecoder(failures){
  var orginal, result;
  var data;
  var success;
  var message, encoded;
  var decoded3;

  message = {};
  encoded = {};
  decoded3 = CreateAndFillByteArray(3, 0);

  orginal = "Hei".split('');
  data = UTF16ToUTF8(orginal);
  success = Base64Encode(data, encoded, message);
  AssertTrue(success, failures);

  success = Base64Decode4Chars(encoded.string, decoded3, message);
  AssertTrue(success, failures);

  result = UTF8ToUTF16(decoded3);

  AssertStringEquals(orginal, result, failures);
}
function TestDecoder2(failures){
  var original;
  var encoded, message;
  var decoded;
  var success;

  message = {};
  decoded = CreateAndFillByteArray(3, 0);
  encoded = {};

  original = CreateByteArray(3);
  SetByte(original, 0, 0);
  SetByte(original, 1, Math.pow(2, 4));
  SetByte(original, 2, Math.pow(2, 8) - 1);
  success = Base64Encode(original, encoded, message);
  AssertTrue(success, failures);

  success = Base64Decode4Chars(encoded.string, decoded, message);
  AssertTrue(success, failures);

  AssertByteArraysEqual(original, decoded, failures);
}
function TestDecoderWithPadding(failures){
  var original;
  var data;
  var result;
  var encoded, message;
  var decoded;
  var success;

  message = {};
  encoded = {};
  decoded = {};

  original = "Hei12".split('');
  data = UTF16ToUTF8(original);
  success = Base64Encode(data, encoded, message);
  AssertTrue(success, failures);

  success = Base64Decode(encoded.string, decoded, message);
  AssertTrue(success, failures);

  result = UTF8ToUTF16(decoded.bytes);

  AssertStringEquals(original, result, failures);
}
function TestDecoderWithPadding2(failures){
  var original;
  var data;
  var result;
  var encoded, message;
  var decoded;
  var success;

  message = {};
  encoded = {};
  decoded = {};

  original = "Hei1".split('');
  data = UTF16ToUTF8(original);
  success = Base64Encode(data, encoded, message);
  AssertTrue(success, failures);

  success = Base64Decode(encoded.string, decoded, message);
  AssertTrue(success, failures);

  result = UTF8ToUTF16(decoded.bytes);

  AssertStringEquals(original, result, failures);
}
function TestDecoderReal1(failures){
  var success;
  var decoded;
  var message;

  message = {};
  decoded = {};

  success = Base64Decode("56Lw4SQJdBIDNUoc+QNvbuQQo/osGyGQzfLfluGLJ+g=".split(''), decoded, message);
  AssertTrue(success, failures);
}
function TestDecoderText(failures){
  var base64, decoded;

  base64 = "4oKs".split('');
  decoded = Base64DecodeToText(base64);
  AssertEquals(decoded[0], 8364, failures);

  base64 = "wqI=".split('');
  decoded = Base64DecodeToText(base64);
  AssertEquals(decoded[0], 162, failures);
}
function test(){
  var failuresReference;
  var failures;

  failuresReference = CreateNumberReference(0);

  TestDecoder(failuresReference);
  TestDecoder2(failuresReference);
  TestDecoderWithPadding(failuresReference);
  TestDecoderWithPadding2(failuresReference);
  TestDecoderReal1(failuresReference);
  TestDecoderText(failuresReference);

  TestEncoder(failuresReference);
  TestEncoder2(failuresReference);
  TestEncoderWithPadding(failuresReference);
  TestEncoderWithPadding2(failuresReference);
  TestEncoderText(failuresReference);

  /* This is too heavy for online use. */
  /*runBatchTest1(failuresReference); */
  failures = failuresReference.numberValue;

  delete(failuresReference);

  return failures;
}
function RunBatchTest1(failures){
  var data;
  var success;
  var encoded4chars, error;
  var decoded3numbers;
  var i;
  var table;
  var validTable;

  encoded4chars = CreateStringReferenceLengthValue(4, ' ');
  error = CreateStringReference("".split(''));
  decoded3numbers = CreateAndFillByteArray(3, 0);

  data = CreateByteArray(3);
  SetByte(data, 0, 0);
  SetByte(data, 1, 0);
  SetByte(data, 2, 0);

  table = GetBase64ReverseTable();
  validTable = GetBase64ValidTable();

  for(i = 0; i < Math.pow(2, 24); i = i + 1){
    success = Base64Encode3Numbers(data, encoded4chars, error);
    AssertTrue(success, failures);
    success = Base64Decode4WithTable(encoded4chars.string, table, validTable, decoded3numbers, error);
    AssertTrue(success, failures);

    AssertEquals(GetByte(data, 0), GetByte(decoded3numbers, 0), failures);
    AssertEquals(GetByte(data, 1), GetByte(decoded3numbers, 1), failures);
    AssertEquals(GetByte(data, 2), GetByte(decoded3numbers, 2), failures);

    SetByte(data, 0, GetByte(data, 0) + 1);
    if(GetByte(data, 0) == 256){
      SetByte(data, 0, 0);
      SetByte(data, 1, GetByte(data, 1) + 1);
      if(GetByte(data, 1) == 256){
        SetByte(data, 1, 0);
        SetByte(data, 2, GetByte(data, 2) + 1);
      }
    }
  }

  delete(validTable);
  delete(table);
}
function RunLongTest1(failures){
  var data;
  var success;
  var i;
  var rng;
  var base64, message;
  var dataRef;

  data = CreateByteArray(20*1024*1024);

  rng = CreatePseudorandomNumberGenerator(0);
  for(i = 0; i < ByteArrayLength(data); i = i + 1){
    SetByte(data, i, PseudorandomNextIntegerBetween(rng, 0, 255));
  }

  /*long start = System.currentTimeMillis(); */
  base64 = {};
  message = {};
  success = Base64Encode(data, base64, message);

  /*long end = System.currentTimeMillis(); */
  /*System.out.println(end - start); */
  AssertTrue(success, failures);

  if(success){
    dataRef = {};
    success = Base64Decode(base64.string, dataRef, message);
    AssertTrue(success, failures);
    if(success){
      for(i = 0; i < ByteArrayLength(data); i = i + 1){
        AssertEquals(GetByte(data, i), GetByte(dataRef.bytes, i), failures);
      }
    }
  }
}
function TestEncoder(failures){
  var str;
  var data;
  var success;
  var encoded;
  var message;

  message = {};
  encoded = CreateStringReferenceLengthValue(4, ' ');

  str = "Hei".split('');

  data = UTF16ToUTF8(str);

  success = Base64Encode3Numbers(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "SGVp".split(''), failures);

  str = "".split('');

  data = UTF16ToUTF8(str);

  success = Base64Encode(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "".split(''), failures);

  str = "1".split('');

  data = UTF16ToUTF8(str);

  success = Base64Encode(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "MQ==".split(''), failures);
}
function TestEncoder2(failures){
  var data;
  var success;
  var encoded;
  var message;

  message = {};

  data = CreateByteArray(3);
  SetByte(data, 0, 0);
  SetByte(data, 1, Math.pow(2, 4));
  SetByte(data, 2, Math.pow(2, 8) - 1);

  encoded = CreateStringReferenceLengthValue(4, ' ');

  success = Base64Encode3Numbers(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "ABD/".split(''), failures);
}
function TestEncoderWithPadding(failures){
  var hei;
  var data;
  var success;
  var encoded;
  var message;

  message = {};
  encoded = {};

  hei = "Hei12".split('');

  data = UTF16ToUTF8(hei);

  success = Base64Encode(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "SGVpMTI=".split(''), failures);
}
function TestEncoderWithPadding2(failures){
  var hei;
  var data;
  var success;
  var encoded;
  var message;

  message = {};

  hei = "Hei1".split('');

  data = UTF16ToUTF8(hei);

  encoded = {};

  success = Base64Encode(data, encoded, message);

  AssertTrue(success, failures);
  AssertStringEquals(encoded.string, "SGVpMQ==".split(''), failures);
}
function TestEncoderText(failures){
  var textNumbers;
  var text, answer, encoded;

  textNumbers = [];
  textNumbers.length = 1;

  textNumbers[0] = 8364;

  text = [];
  text.length = 1;
  text[0] = String.fromCharCode(textNumbers[0]);

  encoded = Base64EncodeFromText(text);

  answer = "4oKs".split('');
  AssertStringEquals(answer, encoded, failures);

  textNumbers[0] = 162;

  text = [];
  text.length = 1;
  text[0] = String.fromCharCode(textNumbers[0]);

  encoded = Base64EncodeFromText(text);

  answer = "wqI=".split('');
  AssertStringEquals(answer, encoded, failures);
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function UnicodeToUTF8(unicode){
  var utf8;
  var lengthx, i, pos, p1, p2, p3, p4, code;

  lengthx = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    code = unicode[i];

    lengthx = lengthx + 1;
    if(code >= 128){
      lengthx = lengthx + 1;
    }
    if(code >= 2048){
      lengthx = lengthx + 1;
    }
    if(code >= 65536){
      lengthx = lengthx + 1;
    }
  }

  utf8 = CreateByteArray(lengthx);

  pos = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    code = unicode[i];

    if(code < 128){
      SetByte(utf8, pos, code);
      pos = pos + 1;
    }else if(code < 2048){
      p1 = code%64;
      p2 = Math.floor(code/64)%64;

      SetByte(utf8, pos, 128 + 64 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }else if(code < 65536){
      p1 = code%64;
      p2 = Math.floor(code/64)%64;
      p3 = Math.floor(code/4096);

      SetByte(utf8, pos, 128 + 64 + 32 + p3);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }else{
      p1 = code%64;
      p2 = Math.floor(code/64)%64;
      p3 = Math.floor(code/4096)%64;
      p4 = Math.floor(code/262144);

      SetByte(utf8, pos, 128 + 64 + 32 + 16 + p4);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p3);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p2);
      pos = pos + 1;
      SetByte(utf8, pos, 128 + p1);
      pos = pos + 1;
    }
  }

  return utf8;
}
function UTF8ToUnicode(utf8){
  var utf;
  var lengthx, i, pos, p1, p2, p3, p4, code;

  lengthx = 0;
  for(i = 0; i < ByteArrayLength(utf8); ){
    code = Math.floor(GetByte(utf8, i)/8)*8;

    if(code < 128){
      lengthx = lengthx + 1;
      i = i + 1;
    }else if(code == 128 + 64){
      lengthx = lengthx + 1;
      i = i + 2;
    }else if(code == 128 + 64 + 32){
      lengthx = lengthx + 1;
      i = i + 3;
    }else if(code == 128 + 64 + 32 + 16){
      lengthx = lengthx + 1;
      i = i + 4;
    }
  }

  utf = [];
  utf.length = lengthx;

  pos = 0;
  for(i = 0; i < ByteArrayLength(utf8); ){
    code = Math.floor(GetByte(utf8, i)/8)*8;

    if(code < 128){
      utf[pos] = GetByte(utf8, i);
      i = i + 1;
      pos = pos + 1;
    }else if(code == 128 + 64){
      p1 = GetByte(utf8, i + 1) - 128;
      p2 = GetByte(utf8, i) - 128 - 64;

      utf[pos] = p2*64 + p1;

      i = i + 2;
      pos = pos + 1;
    }else if(code == 128 + 64 + 32){
      p1 = GetByte(utf8, i + 2) - 128;
      p2 = GetByte(utf8, i + 1) - 128;
      p3 = GetByte(utf8, i) - 128 - 64 - 32;

      utf[pos] = p3*4096 + p2*64 + p1;

      i = i + 3;
      pos = pos + 1;
    }else if(code == 128 + 64 + 32 + 16){
      p1 = GetByte(utf8, i + 3) - 128;
      p2 = GetByte(utf8, i + 2) - 128;
      p3 = GetByte(utf8, i + 1) - 128;
      p4 = GetByte(utf8, i) - 128 - 64 - 32 - 16;

      utf[pos] = p4*262144 + p3*4096 + p2*64 + p1;

      i = i + 4;
      pos = pos + 1;
    }
  }

  return utf;
}
function UTF16ToUnicode(utf16){
  var unicode;
  var lengthx, i, pos, hs, ls, code;
  var surrogateLowerBound, surrogateUpperBound, highSurrogateBase, lowSurrogateBase, highMultiplier, surrogateBase;

  surrogateLowerBound = 55296;
  surrogateUpperBound = 57344;
  highSurrogateBase = 55296;
  lowSurrogateBase = 56320;
  highMultiplier = 1024;
  surrogateBase = 65536;

  lengthx = 0;
  for(i = 0; i < utf16.length; ){
    code = utf16[i].charCodeAt(0);

    if(code < surrogateLowerBound || code >= surrogateUpperBound){
      lengthx = lengthx + 1;
      i = i + 1;
    }else{
      lengthx = lengthx + 1;
      i = i + 2;
    }
  }

  unicode = [];
  unicode.length = lengthx;

  pos = 0;
  for(i = 0; i < utf16.length; ){
    code = utf16[i].charCodeAt(0);

    if(code < surrogateLowerBound || code >= surrogateUpperBound){
      unicode[pos] = utf16[i].charCodeAt(0);
      i = i + 1;
      pos = pos + 1;
    }else{
      hs = utf16[i].charCodeAt(0);
      ls = utf16[i + 1].charCodeAt(0);

      unicode[pos] = (hs - highSurrogateBase)*highMultiplier + (ls - lowSurrogateBase) + surrogateBase;

      i = i + 2;
      pos = pos + 1;
    }
  }

  return unicode;
}
function UnicodeToUTF16(unicode){
  var utf16;
  var lengthx, code, i, pos, hs, ls;
  var highSurrogateBase, lowSurrogateBase, highMultiplier, surrogateBase;

  highSurrogateBase = 55296;
  lowSurrogateBase = 56320;
  highMultiplier = 1024;
  surrogateBase = 65536;

  lengthx = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    if(unicode[i] < surrogateBase){
      lengthx = lengthx + 1;
    }else{
      lengthx = lengthx + 2;
    }
  }

  utf16 = [];
  utf16.length = lengthx;

  pos = 0;
  for(i = 0; i < unicode.length; i = i + 1){
    if(unicode[i] < surrogateBase){
      utf16[pos] = String.fromCharCode(unicode[i]);
      pos = pos + 1;
    }else{
      code = unicode[i] - surrogateBase;
      hs = Math.floor(code/highMultiplier) + highSurrogateBase;
      ls = code%highMultiplier + lowSurrogateBase;

      utf16[pos] = String.fromCharCode(hs);
      pos = pos + 1;
      utf16[pos] = String.fromCharCode(ls);
      pos = pos + 1;
    }
  }

  return utf16;
}
function UTF8ToUTF16(utf8){
  var unicode;
  var utf16;

  unicode = UTF8ToUnicode(utf8);
  utf16 = UnicodeToUTF16(unicode);

  delete(unicode);

  return utf16;
}
function UTF16ToUTF8(utf16){
  var unicode;
  var utf8;

  unicode = UTF16ToUnicode(utf16);
  utf8 = UnicodeToUTF8(unicode);

  delete(unicode);

  return utf8;
}
function IsValidUnicode(unicode){
  var lower, upper, i, code;
  var valid;

  lower = 0;
  upper = 1114112;

  valid = true;
  for(i = 0; i < unicode.length && valid; i = i + 1){
    code = unicode[i];

    if(code == Math.floor(code)){
      if(code >= lower && code < upper){
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function IsValidUtf16(utf16){
  var i, code;
  var valid;
  var surrogateLowerBound, surrogateUpperBound;

  surrogateLowerBound = 55296;
  surrogateUpperBound = 57344;

  valid = true;
  for(i = 0; i < utf16.length && valid; i = i + 1){
    code = utf16[i].charCodeAt(0);

    if(code == Math.floor(code)){
      if(code < surrogateLowerBound || code >= surrogateUpperBound){
      }else if(i + 1 < utf16.length){
        i = i + 1;
        code = utf16[i].charCodeAt(0);

        if(code < surrogateLowerBound || code >= surrogateUpperBound){
          valid = false;
        }
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function IsValidUtf8(utf8){
  var i, code1, code2, code3, code4;
  var valid;

  valid = true;
  for(i = 0; i < ByteArrayLength(utf8) && valid; i = i + 1){
    code1 = GetByte(utf8, i);

    if(code1 == Math.floor(code1)){
      if(code1 < 128){
      }else if(code1 < 128 + 64){
        valid = false;
      }else if(code1 < 128 + 64 + 32){
        if(i + 1 < ByteArrayLength(utf8)){
          i = i + 1;
          code2 = GetByte(utf8, i);

          if(code2 >= 128 && code2 < 128 + 64){
          }else{
            valid = false;
          }
        }else{
          valid = false;
        }
      }else if(code1 < 128 + 64 + 32 + 16){
        if(i + 2 < ByteArrayLength(utf8)){
          i = i + 1;
          code2 = GetByte(utf8, i);
          i = i + 1;
          code3 = GetByte(utf8, i);

          if(code2 >= 128 && code2 < 128 + 64 && code3 >= 128 && code3 < 128 + 64){
          }else{
            valid = false;
          }
        }else{
          valid = false;
        }
      }else if(i + 3 < ByteArrayLength(utf8)){
        i = i + 1;
        code2 = GetByte(utf8, i);
        i = i + 1;
        code3 = GetByte(utf8, i);
        i = i + 1;
        code4 = GetByte(utf8, i);

        if(code2 >= 128 && code2 < 128 + 64 && code3 >= 128 && code3 < 128 + 64 && code4 >= 128 && code4 < 128 + 64){
        }else{
          valid = false;
        }
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }

  return valid;
}
function Negate(x){
  return  -x;
}
function Positive(x){
  return  +x;
}
function Factorial(x){
  var i, f;

  f = 1;

  for(i = 2; i <= x; i = i + 1){
    f = f*i;
  }

  return f;
}
function Round(x){
  return Math.floor(x + 0.5);
}
function BankersRound(x){
  var r;

  if(Absolute(x - Truncate(x)) == 0.5){
    if( !DivisibleBy(Round(x), 2) ){
      r = Round(x) - 1;
    }else{
      r = Round(x);
    }
  }else{
    r = Round(x);
  }

  return r;
}
function Ceil(x){
  return Math.ceil(x);
}
function Floor(x){
  return Math.floor(x);
}
function Truncate(x){
  var t;

  if(x >= 0){
    t = Math.floor(x);
  }else{
    t = Math.ceil(x);
  }

  return t;
}
function Absolute(x){
  return Math.abs(x);
}
function Logarithm(x){
  return Math.log10(x);
}
function NaturalLogarithm(x){
  return Math.log(x);
}
function Sin(x){
  return Math.sin(x);
}
function Cos(x){
  return Math.cos(x);
}
function Tan(x){
  return Math.tan(x);
}
function Asin(x){
  return Math.asin(x);
}
function Acos(x){
  return Math.acos(x);
}
function Atan(x){
  return Math.atan(x);
}
function Atan2(y, x){
  var a;

  /* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors. */
  a = 0;

  if(x > 0){
    a = Atan(y/x);
  }else if(x < 0 && y >= 0){
    a = Atan(y/x) + Math.PI;
  }else if(x < 0 && y < 0){
    a = Atan(y/x) - Math.PI;
  }else if(x == 0 && y > 0){
    a = Math.PI/2;
  }else if(x == 0 && y < 0){
    a =  -Math.PI/2;
  }

  return a;
}
function Squareroot(x){
  return Math.sqrt(x);
}
function Exp(x){
  return Math.exp(x);
}
function DivisibleBy(a, b){
  return ((a%b) == 0);
}
function Combinations(n, k){
  var i, j, c;

  c = 1;
  j = 1;
  i = n - k + 1;

  for(; i <= n; ){
    c = c*i;
    c = c/j;

    i = i + 1;
    j = j + 1;
  }

  return c;
}
function Permutations(n, k){
  var i, c;

  c = 1;

  for(i = n - k + 1; i <= n; i = i + 1){
    c = c*i;
  }

  return c;
}
function EpsilonCompare(a, b, epsilon){
  return Math.abs(a - b) < epsilon;
}
function GreatestCommonDivisor(a, b){
  var t;

  for(; b != 0; ){
    t = b;
    b = a%b;
    a = t;
  }

  return a;
}
function GCDWithSubtraction(a, b){
  var g;

  if(a == 0){
    g = b;
  }else{
    for(; b != 0; ){
      if(a > b){
        a = a - b;
      }else{
        b = b - a;
      }
    }

    g = a;
  }

  return g;
}
function IsInteger(a){
  return (a - Math.floor(a)) == 0;
}
function GreatestCommonDivisorWithCheck(a, b, gcdReference){
  var success;
  var gcd;

  if(IsInteger(a) && IsInteger(b)){
    gcd = GreatestCommonDivisor(a, b);
    gcdReference.numberValue = gcd;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function LeastCommonMultiple(a, b){
  var lcm;

  if(a > 0 && b > 0){
    lcm = Math.abs(a*b)/GreatestCommonDivisor(a, b);
  }else{
    lcm = 0;
  }

  return lcm;
}
function Sign(a){
  var s;

  if(a > 0){
    s = 1;
  }else if(a < 0){
    s =  -1;
  }else{
    s = 0;
  }

  return s;
}
function Max(a, b){
  return Math.max(a, b);
}
function Min(a, b){
  return Math.min(a, b);
}
function Power(a, b){
  return Math.pow(a, b);
}
function Gamma(x){
  return LanczosApproximation(x);
}
function LogGamma(x){
  return Math.log(Gamma(x));
}
function LanczosApproximation(z){
  var p;
  var i, y, t, x;

  p = [];
  p.length = 8;
  p[0] = 676.5203681218851;
  p[1] =  -1259.1392167224028;
  p[2] = 771.32342877765313;
  p[3] =  -176.61502916214059;
  p[4] = 12.507343278686905;
  p[5] =  -0.13857109526572012;
  p[6] = 9.9843695780195716e-6;
  p[7] = 1.5056327351493116e-7;

  if(z < 0.5){
    y = Math.PI/(Math.sin(Math.PI*z)*LanczosApproximation(1 - z));
  }else{
    z = z - 1;
    x = 0.99999999999980993;
    for(i = 0; i < p.length; i = i + 1){
      x = x + p[i]/(z + i + 1);
    }
    t = z + p.length - 0.5;
    y = Math.sqrt(2*Math.PI)*Math.pow(t, z + 0.5)*Math.exp( -t)*x;
  }

  return y;
}
function Beta(x, y){
  return Gamma(x)*Gamma(y)/Gamma(x + y);
}
function Sinh(x){
  return (Math.exp(x) - Math.exp( -x))/2;
}
function Cosh(x){
  return (Math.exp(x) + Math.exp( -x))/2;
}
function Tanh(x){
  return Sinh(x)/Cosh(x);
}
function Cot(x){
  return 1/Math.tan(x);
}
function Sec(x){
  return 1/Math.cos(x);
}
function Csc(x){
  return 1/Math.sin(x);
}
function Coth(x){
  return Cosh(x)/Sinh(x);
}
function Sech(x){
  return 1/Cosh(x);
}
function Csch(x){
  return 1/Sinh(x);
}
function Error(x){
  var y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

  if(x == 0){
    y = 0;
  }else if(x < 0){
    y =  -Error( -x);
  }else{
    c1 =  -1.26551223;
    c2 =  +1.00002368;
    c3 =  +0.37409196;
    c4 =  +0.09678418;
    c5 =  -0.18628806;
    c6 =  +0.27886807;
    c7 =  -1.13520398;
    c8 =  +1.48851587;
    c9 =  -0.82215223;
    c10 =  +0.17087277;

    t = 1/(1 + 0.5*Math.abs(x));

    tau = t*Math.exp( -(Math.pow(x, 2)) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

    y = 1 - tau;
  }

  return y;
}
function ErrorInverse(x){
  var y, a, t;

  a = (8*(Math.PI - 3))/(3*Math.PI*(4 - Math.PI));

  t = 2/(Math.PI*a) + Math.log(1 - Math.pow(x, 2))/2;
  y = Sign(x)*Math.sqrt(Math.sqrt(Math.pow(t, 2) - Math.log(1 - Math.pow(x, 2))/a) - t);

  return y;
}
function FallingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x - k);
  }

  return y;
}
function RisingFactorial(x, n){
  var k, y;

  y = 1;

  for(k = 0; k <= n - 1; k = k + 1){
    y = y*(x + k);
  }

  return y;
}
function Hypergeometric(a, b, c, z, maxIterations, precision){
  var y;

  if(Math.abs(z) >= 0.5){
    y = Math.pow(1 - z,  -a)*HypergeometricDirect(a, c - b, c, z/(z - 1), maxIterations, precision);
  }else{
    y = HypergeometricDirect(a, b, c, z, maxIterations, precision);
  }

  return y;
}
function HypergeometricDirect(a, b, c, z, maxIterations, precision){
  var y, yp, n;
  var done;

  y = 0;
  done = false;

  for(n = 0; n < maxIterations &&  !done ; n = n + 1){
    yp = RisingFactorial(a, n)*RisingFactorial(b, n)/RisingFactorial(c, n)*Math.pow(z, n)/Factorial(n);
    if(Math.abs(yp) < precision){
      done = true;
    }
    y = y + yp;
  }

  return y;
}
function BernouilliNumber(n){
  return AkiyamaTanigawaAlgorithm(n);
}
function AkiyamaTanigawaAlgorithm(n){
  var m, j, B;
  var A;

  A = [];
  A.length = n + 1;

  for(m = 0; m <= n; m = m + 1){
    A[m] = 1/(m + 1);
    for(j = m; j >= 1; j = j - 1){
      A[j - 1] = j*(A[j - 1] - A[j]);
    }
  }

  B = A[0];

  delete(A);

  return B;
}
function ReadXbytes(data, position, lengthx){
  var r;
  var i;

  r = CreateByteArray(lengthx);

  for(i = 0; i < lengthx; i = i + 1){
    r.bytes[i] = ReadByte(data, position);
  }

  return r;
}
function Read4bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 24)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function Read2bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function ReadByte(data, position){
  var next;

  next = data.bytes[position.numberValue];
  position.numberValue = position.numberValue + 1;

  return next;
}
function Read4bytesLE(data, position){
  var r;

  r = 0;
  r = r + ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 24)*ReadByte(data, position);

  return r;
}
function WriteByte(data, b, position){
  data.bytes[position.numberValue] = b;
  position.numberValue = position.numberValue + 1;
}
function Write2BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write4BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write2BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function Write4BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function WriteStringBytes(data, cs, position){
  var i, v;

  for(i = 0; i < cs.length; i = i + 1){
    v = cs[i].charCodeAt(0);
    WriteByte(data, v, position);
  }
}
function BytesRound(x){
  return Math.floor(x + 0.5);
}
function ByteArrayToNumberArray(src){
  var dst;
  var i, len;

  len = src.bytes.length;
  dst = [];
  dst.length = len;
  for(i = 0; i < len; i = i + 1){
    dst[i] = src.bytes[i];
  }

  return dst;
}
function NumberArrayToByteArray(src){
  var dst;
  var i, len;

  len = src.length;
  dst = {};
  dst.bytes = [];
  dst.bytes.length = len;
  for(i = 0; i < len; i = i + 1){
    dst.bytes[i] = src[i];
  }

  return dst;
}
function ByteArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length && equal; i = i + 1){
      if(a.bytes[i] != b.bytes[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function CopyByteArray(a){
  var i;
  var n;

  n = {};
  n.bytes = [];
  n.bytes.length = a.bytes.length;

  for(i = 0; i < a.bytes.length; i = i + 1){
    n.bytes[i] = a.bytes[i];
  }

  return n;
}
function ByteArrayLength(response){
  return response.bytes.length;
}
function CreateAndFillByteArray(lengthx, value){
  var bytes;
  var i;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    bytes.bytes[i] = value;
  }

  return bytes;
}
function CreateByteArray(lengthx){
  var bytes;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  return bytes;
}
function SetByte(array, index, value){
  array.bytes[index] = value;
}
function GetByte(array, index){
  return array.bytes[index];
}
function AssertByteArraysEqual(a, b, failures){
  var i;

  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length; i = i + 1){
      if(GetByte(a, i) != GetByte(b, i)){
        failures.numberValue = failures.numberValue + 1;
      }
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function FreeByteArray(byteArray){
  delete(byteArray.bytes);
  delete(byteArray);
}
function CopyByteArrayRange(a, from, to, b){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.bytes.length && to >= 0 && to <= a.bytes.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a.bytes[from + i];
    }

    b.bytes = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function BytesToTextBase16(bytes){
  var comb;
  var i, v;
  var r;

  r = [];
  r.length = bytes.bytes.length*2;
  comb = GenerateBase16ByteCombinations();

  for(i = 0; i < bytes.bytes.length; i = i + 1){
    v = bytes.bytes[i];
    r[2*i + 0] = comb[v].string[0];
    r[2*i + 1] = comb[v].string[1];
  }

  FreeBase64ByteCombinations(comb);

  return r;
}
function TextToBytesBase16WithCheck(string, bytes, message){
  var comb;
  var i, n, c, d;
  var reverseBase16;
  var codes;
  var success;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    bytes.bytes = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    success = true;
    for(i = 0; i < string.length/2 && success; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      if(c == 'a'.charCodeAt(0)){
        c = 'A'.charCodeAt(0);
      }
      if(c == 'b'.charCodeAt(0)){
        c = 'B'.charCodeAt(0);
      }
      if(c == 'c'.charCodeAt(0)){
        c = 'C'.charCodeAt(0);
      }
      if(c == 'd'.charCodeAt(0)){
        c = 'D'.charCodeAt(0);
      }
      if(c == 'e'.charCodeAt(0)){
        c = 'E'.charCodeAt(0);
      }
      if(c == 'f'.charCodeAt(0)){
        c = 'F'.charCodeAt(0);
      }

      if(d == 'a'.charCodeAt(0)){
        d = 'A'.charCodeAt(0);
      }
      if(d == 'b'.charCodeAt(0)){
        d = 'B'.charCodeAt(0);
      }
      if(d == 'c'.charCodeAt(0)){
        d = 'C'.charCodeAt(0);
      }
      if(d == 'd'.charCodeAt(0)){
        d = 'D'.charCodeAt(0);
      }
      if(d == 'e'.charCodeAt(0)){
        d = 'E'.charCodeAt(0);
      }
      if(d == 'f'.charCodeAt(0)){
        d = 'F'.charCodeAt(0);
      }

      success = true;
      success = success && (c == '0'.charCodeAt(0) || c == '1'.charCodeAt(0) || c == '2'.charCodeAt(0) || c == '3'.charCodeAt(0) || c == '4'.charCodeAt(0) || c == '5'.charCodeAt(0) || c == '6'.charCodeAt(0) || c == '7'.charCodeAt(0) || c == '8'.charCodeAt(0) || c == '9'.charCodeAt(0) || c == 'A'.charCodeAt(0) || c == 'B'.charCodeAt(0) || c == 'C'.charCodeAt(0) || c == 'D'.charCodeAt(0) || c == 'E'.charCodeAt(0) || c == 'F'.charCodeAt(0));
      success = success && (d == '0'.charCodeAt(0) || d == '1'.charCodeAt(0) || d == '2'.charCodeAt(0) || d == '3'.charCodeAt(0) || d == '4'.charCodeAt(0) || d == '5'.charCodeAt(0) || d == '6'.charCodeAt(0) || d == '7'.charCodeAt(0) || d == '8'.charCodeAt(0) || d == '9'.charCodeAt(0) || d == 'A'.charCodeAt(0) || d == 'B'.charCodeAt(0) || d == 'C'.charCodeAt(0) || d == 'D'.charCodeAt(0) || d == 'E'.charCodeAt(0) || d == 'F'.charCodeAt(0));

      if(success){
        n = reverseBase16[c]*16 + reverseBase16[d];

        bytes.bytes.bytes[i] = n;
      }else{
        success = false;
        message.string = "Hex-string can only contain 0-9, A-F or a-f.".split('');
      }
    }

    FreeBase64ByteCombinations(comb);
  }else{
    bytes.bytes = CreateByteArray(0);
    success = false;
    message.string = "Hex-string must be an even number of characters.".split('');
  }

  delete(reverseBase16);

  return success;
}
function TextToBytesBase16(string){
  var comb;
  var i, n, c, d;
  var r;
  var reverseBase16;
  var codes;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    r = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    for(i = 0; i < string.length/2; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      n = reverseBase16[c]*16 + reverseBase16[d];

      r.bytes[i] = n;
    }

    FreeBase64ByteCombinations(comb);
  }else{
    r = CreateByteArray(0);
  }

  delete(reverseBase16);

  return r;
}
function FreeBase64ByteCombinations(comb){
  var i;
  for(i = 0; i < 256; i = i + 1){
    FreeStringReference(comb[i]);
  }
  delete(comb);
}
function GenerateBase16ByteCombinations(){
  var comb;
  var codes;
  var i, j;
  comb = [];
  comb.length = 256;

  codes = "0123456789ABCDEF".split('');

  for(i = 0; i < 256; i = i + 1){
    comb[i] = {};
    comb[i].string = [];
    comb[i].string.length = 2;
  }

  for(j = 0; j < 16; j = j + 1){
    for(i = 0; i < 16; i = i + 1){
      comb[j*16 + i].string[1] = codes[i];
      comb[j*16 + i].string[0] = codes[j];
    }
  }

  return comb;
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function CreateLinearCongruentialGeneratorNumericalRecipes(seed){
  return CreateLinearCongruentialGeneratorCustom(Math.pow(2, 32), 1664525, 1013904223, seed);
}
function CreateLinearCongruentialGeneratorCustom(modulus, multiplier, increment, seed){
  var lcg;

  lcg = {};
  lcg.m = modulus;
  lcg.a = multiplier;
  lcg.c = increment;
  lcg.x = seed;

  return lcg;
}
function LinearCongruentialGeneratorNextNumber(lcg){
  lcg.x = Math.floor((lcg.a*lcg.x + lcg.c)%lcg.m);
  return lcg.x/lcg.m;
}
function CreatePseudorandomNumberGenerator(seed){
  var prg;

  prg = {};
  prg.lcg = CreateLinearCongruentialGeneratorNumericalRecipes(seed);

  return prg;
}
function PseudorandomNextNumber(prg){
  return LinearCongruentialGeneratorNextNumber(prg.lcg);
}
function PseudorandomNextInteger(prg, n){
  return Math.floor(PseudorandomNextNumber(prg)*n);
}
function PseudorandomNextIntegerBetween(prg, a, b){
  return Math.ceil(a) + Math.floor(PseudorandomNextNumber(prg)*(b - a));
}


module.exports = {
	GetBase64Table: GetBase64Table,
	GetBase64ReverseTable: GetBase64ReverseTable,
	GetBase64ValidTable: GetBase64ValidTable,
	IsValidBase64Character: IsValidBase64Character,
	Base64Encode: Base64Encode,
	Base64Encode3Numbers: Base64Encode3Numbers,
	Base64Encode3NumbersNoChecks: Base64Encode3NumbersNoChecks,
	GetBase64CharacterForNumber: GetBase64CharacterForNumber,
	Base64EncodeFromText: Base64EncodeFromText,
	Base64Decode: Base64Decode,
	Base64Decode4Chars: Base64Decode4Chars,
	Base64Decode4WithTable: Base64Decode4WithTable,
	IsValidBase64CharacterTable: IsValidBase64CharacterTable,
	Base64Decode4NoChecks: Base64Decode4NoChecks,
	Base64Decode4WithTableNoChecks: Base64Decode4WithTableNoChecks,
	GetBase64NumberForCharacter: GetBase64NumberForCharacter,
	Base64DecodeToText: Base64DecodeToText,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	UnicodeToUTF8: UnicodeToUTF8,
	UTF8ToUnicode: UTF8ToUnicode,
	UTF16ToUnicode: UTF16ToUnicode,
	UnicodeToUTF16: UnicodeToUTF16,
	UTF8ToUTF16: UTF8ToUTF16,
	UTF16ToUTF8: UTF16ToUTF8,
	IsValidUnicode: IsValidUnicode,
	IsValidUtf16: IsValidUtf16,
	IsValidUtf8: IsValidUtf8,
	Negate: Negate,
	Positive: Positive,
	Factorial: Factorial,
	Round: Round,
	BankersRound: BankersRound,
	Ceil: Ceil,
	Floor: Floor,
	Truncate: Truncate,
	Absolute: Absolute,
	Logarithm: Logarithm,
	NaturalLogarithm: NaturalLogarithm,
	Sin: Sin,
	Cos: Cos,
	Tan: Tan,
	Asin: Asin,
	Acos: Acos,
	Atan: Atan,
	Atan2: Atan2,
	Squareroot: Squareroot,
	Exp: Exp,
	DivisibleBy: DivisibleBy,
	Combinations: Combinations,
	Permutations: Permutations,
	EpsilonCompare: EpsilonCompare,
	GreatestCommonDivisor: GreatestCommonDivisor,
	GCDWithSubtraction: GCDWithSubtraction,
	IsInteger: IsInteger,
	GreatestCommonDivisorWithCheck: GreatestCommonDivisorWithCheck,
	LeastCommonMultiple: LeastCommonMultiple,
	Sign: Sign,
	Max: Max,
	Min: Min,
	Power: Power,
	Gamma: Gamma,
	LogGamma: LogGamma,
	LanczosApproximation: LanczosApproximation,
	Beta: Beta,
	Sinh: Sinh,
	Cosh: Cosh,
	Tanh: Tanh,
	Cot: Cot,
	Sec: Sec,
	Csc: Csc,
	Coth: Coth,
	Sech: Sech,
	Csch: Csch,
	Error: Error,
	ErrorInverse: ErrorInverse,
	FallingFactorial: FallingFactorial,
	RisingFactorial: RisingFactorial,
	Hypergeometric: Hypergeometric,
	HypergeometricDirect: HypergeometricDirect,
	BernouilliNumber: BernouilliNumber,
	AkiyamaTanigawaAlgorithm: AkiyamaTanigawaAlgorithm,
	ReadXbytes: ReadXbytes,
	Read4bytesBE: Read4bytesBE,
	Read2bytesBE: Read2bytesBE,
	ReadByte: ReadByte,
	Read4bytesLE: Read4bytesLE,
	WriteByte: WriteByte,
	Write2BytesLE: Write2BytesLE,
	Write4BytesLE: Write4BytesLE,
	Write2BytesBE: Write2BytesBE,
	Write4BytesBE: Write4BytesBE,
	WriteStringBytes: WriteStringBytes,
	BytesRound: BytesRound,
	ByteArrayToNumberArray: ByteArrayToNumberArray,
	NumberArrayToByteArray: NumberArrayToByteArray,
	ByteArraysEqual: ByteArraysEqual,
	CopyByteArray: CopyByteArray,
	ByteArrayLength: ByteArrayLength,
	CreateAndFillByteArray: CreateAndFillByteArray,
	CreateByteArray: CreateByteArray,
	SetByte: SetByte,
	GetByte: GetByte,
	AssertByteArraysEqual: AssertByteArraysEqual,
	FreeByteArray: FreeByteArray,
	CopyByteArrayRange: CopyByteArrayRange,
	BytesToTextBase16: BytesToTextBase16,
	TextToBytesBase16WithCheck: TextToBytesBase16WithCheck,
	TextToBytesBase16: TextToBytesBase16,
	FreeBase64ByteCombinations: FreeBase64ByteCombinations,
	GenerateBase16ByteCombinations: GenerateBase16ByteCombinations,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	CreateLinearCongruentialGeneratorNumericalRecipes: CreateLinearCongruentialGeneratorNumericalRecipes,
	CreateLinearCongruentialGeneratorCustom: CreateLinearCongruentialGeneratorCustom,
	LinearCongruentialGeneratorNextNumber: LinearCongruentialGeneratorNextNumber,
	CreatePseudorandomNumberGenerator: CreatePseudorandomNumberGenerator,
	PseudorandomNextNumber: PseudorandomNextNumber,
	PseudorandomNextInteger: PseudorandomNextInteger,
	PseudorandomNextIntegerBetween: PseudorandomNextIntegerBetween,
	test: test
};